<!-- HTML header for doxygen 1.8.18-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=9" />
    <meta name="generator" content="Doxygen 1.9.1" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <title>VizBlocks: src/RotaryEncoder.h Source File</title>
    <link href="tabs.css" rel="stylesheet" type="text/css" />
    <script type="text/javascript" src="jquery.js"></script>
    <script type="text/javascript" src="dynsections.js"></script>
     <link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
    <link href="my_customdoxygen.css" rel="stylesheet" type="text/css" />
  </head>
  <body>
    <div id="top">
      <!-- do not remove this div, it is closed by doxygen! -->
      <header id="header" class="desktop">
        <div>
          <div class="inner-header">
            <div class="logotype">
              <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/" aria-hidden="true" title="Site home"
                >VizBlocks</a
              >
            </div>
            <div class="navigation">
              <button
                onclick="toggleBurger()"
                type="button"
                aria-label="toggle burger menu"
              >
                <i class="fa fa-bars"></i>
              </button>
              <nav id="menu" class="collapse">
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/" class="home">Home</a>
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/about" class="about">About</a>
                <a
                  href="https://edinburgh-college-of-art.github.io/vizblocks-website/tutorials/0_getting_started.html"
                  class="start"
                  >Get Started</a
                >
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/tutorials" class="tutorials"
                  >Tutorials</a
                >
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/docs/html" class="docs"
                  >Technical Info</a
                >
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/contact" class="content">Contact</a>
              </nav>
            </div>
          </div>
        </div>
        <script>
          const toggleBurger = () => {
            const menu = document.getElementById("menu");
            if (menu.className === "collapse") {
              menu.className = "extend";
            } else {
              menu.className = "collapse";
            }
          };
          const touchDevice = "ontouchstart" in document.documentElement;
          if (touchDevice) {
            const header = document.getElementById("header");
            header.className = "mobile";
          }
        </script>
      </header>
      <!-- end header part -->
    </div>
  </body>
</html>
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">RotaryEncoder.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_rotary_encoder_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#ifndef ROTARYENCODER_h</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#define ROTARYENCODER_h</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160; </div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#include &lt;Arduino.h&gt;</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div>
<div class="line"><a name="l00019"></a><span class="lineno"><a class="line" href="class_rotary_encoder.html">   19</a></span>&#160;<span class="keyword">class </span><a class="code" href="class_rotary_encoder.html">RotaryEncoder</a></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;{</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;    <span class="keywordtype">int</span> _pinA;</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;    <span class="keywordtype">int</span> _pinB;</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;    <span class="keywordtype">int</span> _id;</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160; </div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    <span class="keyword">volatile</span> <span class="keywordtype">int</span> _state[2];</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    <span class="keyword">volatile</span> <span class="keywordtype">int</span> _position;</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160; </div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;    <span class="keyword">volatile</span> <span class="keywordtype">bool</span> _inputFlag = <span class="keyword">false</span>;</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    <span class="keywordtype">bool</span> _changeFlag = <span class="keyword">false</span>;</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160; </div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> _previousTimer;</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    <span class="keywordtype">int</span> _interval = 200;</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160; </div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    void (*_cb)(<a class="code" href="class_rotary_encoder.html">RotaryEncoder</a>*, uint8_t, int);</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160; </div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    <span class="keywordtype">int</span> movements[5][4][4] = {</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;        { <span class="comment">// No movement</span></div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;            {0, 0, 0, 0},</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;            {0, 1, 0, 1},</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;            {1, 0, 1, 0},</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;            {1, 1, 1, 1}</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;        },</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;        { <span class="comment">// +1</span></div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;            {0, 0, 0, 1},</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;            {0, 1, 1, 1},</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;            {1, 0, 0, 0},</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;            {1, 1, 1, 0}</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;        },</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;        { <span class="comment">// -1</span></div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;            {0, 0, 1, 0},</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;            {0, 1, 0, 0},</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;            {1, 0, 1, 1},</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;            {1, 1, 0, 1}</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;        },</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;        { <span class="comment">// +2</span></div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;            {0, 0, 1, 1},</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;            {1, 1, 0, 0}</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;        },</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;        { <span class="comment">// -2</span></div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;            {0, 1, 1, 0},</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;            {1, 0, 0, 1}</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;        },</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    };</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160; </div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;    <span class="keywordtype">void</span> _setState(<span class="keywordtype">int</span> a, <span class="keywordtype">int</span> b);</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160; </div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    <span class="keywordtype">void</span> _incrementPosition(<span class="keywordtype">int</span> delta);</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160; </div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;    <span class="keywordtype">int</span> _findChange(<span class="keywordtype">int</span> state1[2], <span class="keyword">volatile</span> <span class="keywordtype">int</span> state2[2]);</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160; </div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;    <span class="keywordtype">boolean</span> _compareArrays(<span class="keywordtype">int</span> a[4], <span class="keywordtype">int</span> b[4]);</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160; </div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160; </div>
<div class="line"><a name="l00094"></a><span class="lineno"><a class="line" href="class_rotary_encoder.html#a492bcf97569c21fe3b050d5ee05f5240">   94</a></span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> uint8_t <a class="code" href="class_rotary_encoder.html#a492bcf97569c21fe3b050d5ee05f5240">kEventStableUpdate</a> = 0;</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160; </div>
<div class="line"><a name="l00099"></a><span class="lineno"><a class="line" href="class_rotary_encoder.html#acca85bf302bd19eb2357518d6ce53569">   99</a></span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> uint8_t <a class="code" href="class_rotary_encoder.html#acca85bf302bd19eb2357518d6ce53569">kEventUnstableUpdate</a> = 1;</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160; </div>
<div class="line"><a name="l00104"></a><span class="lineno"><a class="line" href="class_rotary_encoder.html#ad73cb09b417e3b8c1bea31a00ccae54f">  104</a></span>&#160;    <a class="code" href="class_rotary_encoder.html#ad73cb09b417e3b8c1bea31a00ccae54f">RotaryEncoder</a>(<span class="keywordtype">int</span> pinA, <span class="keywordtype">int</span> pinB, <span class="keywordtype">int</span> <span class="keywordtype">id</span> = 99);</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160; </div>
<div class="line"><a name="l00113"></a><span class="lineno"><a class="line" href="class_rotary_encoder.html#a7cc6dcb7afb68e81546966a1ec24d027">  113</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_rotary_encoder.html#a7cc6dcb7afb68e81546966a1ec24d027">initInterrupts</a>(<span class="keywordtype">void</span> (*<span class="keyword">function</span>)());</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160; </div>
<div class="line"><a name="l00119"></a><span class="lineno"><a class="line" href="class_rotary_encoder.html#a3bd9303422d4287e96ea83c181f3fcd4">  119</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_rotary_encoder.html#a3bd9303422d4287e96ea83c181f3fcd4">setEventHandler</a>(<span class="keywordtype">void</span> (*<span class="keyword">function</span>)(<a class="code" href="class_rotary_encoder.html">RotaryEncoder</a>*, uint8_t, <span class="keywordtype">int</span>));</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160; </div>
<div class="line"><a name="l00124"></a><span class="lineno"><a class="line" href="class_rotary_encoder.html#a39492fe10475d3251ebad39f8ec17fc8">  124</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="class_rotary_encoder.html#a39492fe10475d3251ebad39f8ec17fc8">getPostition</a>();</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160; </div>
<div class="line"><a name="l00129"></a><span class="lineno"><a class="line" href="class_rotary_encoder.html#add03486f3ea45ab300b2735a19f6c632">  129</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="class_rotary_encoder.html#add03486f3ea45ab300b2735a19f6c632">getId</a>();</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160; </div>
<div class="line"><a name="l00134"></a><span class="lineno"><a class="line" href="class_rotary_encoder.html#ac91df8b97b799e9411cda5eb4ba5de9c">  134</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_rotary_encoder.html#ac91df8b97b799e9411cda5eb4ba5de9c">setPosition</a>(<span class="keywordtype">int</span> value);</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160; </div>
<div class="line"><a name="l00140"></a><span class="lineno"><a class="line" href="class_rotary_encoder.html#a6d0692adb7f49c186b60d61c4b5ed594">  140</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_rotary_encoder.html#a6d0692adb7f49c186b60d61c4b5ed594">check</a>();</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160; </div>
<div class="line"><a name="l00147"></a><span class="lineno"><a class="line" href="class_rotary_encoder.html#a5e2bc49ea9072d4932612ded0cfcfabf">  147</a></span>&#160;    <span class="keywordtype">void</span> ICACHE_RAM_ATTR <a class="code" href="class_rotary_encoder.html#a5e2bc49ea9072d4932612ded0cfcfabf">tick</a>();</div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160; </div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;};</div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160; </div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="ttc" id="aclass_rotary_encoder_html"><div class="ttname"><a href="class_rotary_encoder.html">RotaryEncoder</a></div><div class="ttdoc">Event-driven rotary encoder class. Events are split into stable and unstable updates to prevent flood...</div><div class="ttdef"><b>Definition:</b> RotaryEncoder.h:20</div></div>
<div class="ttc" id="aclass_rotary_encoder_html_a39492fe10475d3251ebad39f8ec17fc8"><div class="ttname"><a href="class_rotary_encoder.html#a39492fe10475d3251ebad39f8ec17fc8">RotaryEncoder::getPostition</a></div><div class="ttdeci">int getPostition()</div><div class="ttdoc">Returns the current encoder postion.</div></div>
<div class="ttc" id="aclass_rotary_encoder_html_a3bd9303422d4287e96ea83c181f3fcd4"><div class="ttname"><a href="class_rotary_encoder.html#a3bd9303422d4287e96ea83c181f3fcd4">RotaryEncoder::setEventHandler</a></div><div class="ttdeci">void setEventHandler(void(*function)(RotaryEncoder *, uint8_t, int))</div><div class="ttdoc">Set the function that is called any time an encoder event is detected. Some example callback function...</div></div>
<div class="ttc" id="aclass_rotary_encoder_html_a492bcf97569c21fe3b050d5ee05f5240"><div class="ttname"><a href="class_rotary_encoder.html#a492bcf97569c21fe3b050d5ee05f5240">RotaryEncoder::kEventStableUpdate</a></div><div class="ttdeci">static const uint8_t kEventStableUpdate</div><div class="ttdoc">Event ID for a stable update (potentiometer has been changed, then been stable longer than _interval)...</div><div class="ttdef"><b>Definition:</b> RotaryEncoder.h:94</div></div>
<div class="ttc" id="aclass_rotary_encoder_html_a5e2bc49ea9072d4932612ded0cfcfabf"><div class="ttname"><a href="class_rotary_encoder.html#a5e2bc49ea9072d4932612ded0cfcfabf">RotaryEncoder::tick</a></div><div class="ttdeci">void ICACHE_RAM_ATTR tick()</div><div class="ttdoc">Raises the button's _inputFlag. This should be wrapped in a function in the global scope and fed into...</div></div>
<div class="ttc" id="aclass_rotary_encoder_html_a6d0692adb7f49c186b60d61c4b5ed594"><div class="ttname"><a href="class_rotary_encoder.html#a6d0692adb7f49c186b60d61c4b5ed594">RotaryEncoder::check</a></div><div class="ttdeci">void check()</div><div class="ttdoc">Polls the encoders's _inputFlag and detects events. This should be called in the sketch's loop() func...</div></div>
<div class="ttc" id="aclass_rotary_encoder_html_a7cc6dcb7afb68e81546966a1ec24d027"><div class="ttname"><a href="class_rotary_encoder.html#a7cc6dcb7afb68e81546966a1ec24d027">RotaryEncoder::initInterrupts</a></div><div class="ttdeci">void initInterrupts(void(*function)())</div><div class="ttdoc">Set the function to be called when a pin interrupt occurs. Ideally this wouldn't be needed and the pi...</div></div>
<div class="ttc" id="aclass_rotary_encoder_html_ac91df8b97b799e9411cda5eb4ba5de9c"><div class="ttname"><a href="class_rotary_encoder.html#ac91df8b97b799e9411cda5eb4ba5de9c">RotaryEncoder::setPosition</a></div><div class="ttdeci">void setPosition(int value)</div><div class="ttdoc">Sets the encoder postion. Useful for resetting it back to zero for example.</div></div>
<div class="ttc" id="aclass_rotary_encoder_html_acca85bf302bd19eb2357518d6ce53569"><div class="ttname"><a href="class_rotary_encoder.html#acca85bf302bd19eb2357518d6ce53569">RotaryEncoder::kEventUnstableUpdate</a></div><div class="ttdeci">static const uint8_t kEventUnstableUpdate</div><div class="ttdoc">Event ID for a stable update (potentiometer has been changed, but not stopped moving yet).</div><div class="ttdef"><b>Definition:</b> RotaryEncoder.h:99</div></div>
<div class="ttc" id="aclass_rotary_encoder_html_ad73cb09b417e3b8c1bea31a00ccae54f"><div class="ttname"><a href="class_rotary_encoder.html#ad73cb09b417e3b8c1bea31a00ccae54f">RotaryEncoder::RotaryEncoder</a></div><div class="ttdeci">RotaryEncoder(int pinA, int pinB, int id=99)</div><div class="ttdoc">Class constructor.</div></div>
<div class="ttc" id="aclass_rotary_encoder_html_add03486f3ea45ab300b2735a19f6c632"><div class="ttname"><a href="class_rotary_encoder.html#add03486f3ea45ab300b2735a19f6c632">RotaryEncoder::getId</a></div><div class="ttdeci">int getId()</div><div class="ttdoc">Returns the encoder id.</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- HTML footer for doxygen 1.8.18-->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.9.1
</small></address>
</body>
</html>
